Index: binaries/data/mods/public/gui/common/functions_utility.js
===================================================================
--- binaries/data/mods/public/gui/common/functions_utility.js	(revision 17027)
+++ binaries/data/mods/public/gui/common/functions_utility.js	(working copy)
@@ -148,6 +148,13 @@
 
 // ====================================================================
 
+function sameColor(color1, color2)
+{
+    return color1.r === color2.r && color1.g === color2.g && color1.b === color2.b;
+}
+
+// ====================================================================
+
 /**
  * Convert time in milliseconds to [hh:]mm:ss string representation.
  * @param time Time period in milliseconds (integer)
Index: binaries/data/mods/public/gui/gamesetup/gamesetup.js
===================================================================
--- binaries/data/mods/public/gui/gamesetup/gamesetup.js	(revision 17027)
+++ binaries/data/mods/public/gui/gamesetup/gamesetup.js	(working copy)
@@ -8,6 +8,8 @@
 const g_VictoryConditions = prepareForDropdown(g_Settings ? g_Settings.VictoryConditions : undefined);
 const g_PopulationCapacities = prepareForDropdown(g_Settings ? g_Settings.PopulationCapacities : undefined);
 const g_StartingResources = prepareForDropdown(g_Settings ? g_Settings.StartingResources : undefined);
+// Gaia color should not be selectable.
+const g_PlayerColors = initPlayerDefaults().slice(1).map(playerData => playerData.Color);
 
 ////////////////////////////////////////////////////////////////////////////////////////////////
 
@@ -375,6 +377,35 @@
 			updateGameAttributes();
 		};
 
+		// Populate color drop-down lists.
+		var colorPicker = Engine.GetGUIObjectByName("playerColorPicker["+i+"]");
+		colorPicker.list = g_PlayerColors.map(color => '[font="sans-stroke-14"][color="' + color.r + ' ' + color.g + ' ' + color.b + '"]■[/color][/font]');
+		colorPicker.list_data = g_PlayerColors.map((color, index) => index);
+		colorPicker.selected = -1;
+
+		// Update color
+		colorPicker.onSelectionChange = function()
+		{
+			if (this.selected == -1)
+				return;
+
+			// Add missing properties
+			g_GameAttributes.settings.PlayerData.forEach((pData, index) => {
+				if (!pData.Color)
+					pData.Color = g_PlayerColors[index];
+			});
+
+			// If someone else has that color, give him/her the old one
+			let playerID = g_GameAttributes.settings.PlayerData.findIndex(pData => sameColor(g_PlayerColors[this.selected], pData.Color));
+			if (playerID != -1)
+				g_GameAttributes.settings.PlayerData[playerID].Color = g_GameAttributes.settings.PlayerData[playerSlot].Color;
+
+			g_GameAttributes.settings.PlayerData[playerSlot].Color = g_PlayerColors[this.selected];
+
+			if (!g_IsInGuiUpdate)
+				updateGameAttributes();
+		}
+
 		// Set events
 		var civ = Engine.GetGUIObjectByName("playerCiv["+i+"]");
 		civ.onSelectionChange = function() {
@@ -1424,6 +1455,7 @@
 		var pTeam = Engine.GetGUIObjectByName("playerTeam["+i+"]");
 		var pTeamText = Engine.GetGUIObjectByName("playerTeamText["+i+"]");
 		var pColor = Engine.GetGUIObjectByName("playerColor["+i+"]");
+		var pColorPicker = Engine.GetGUIObjectByName("playerColorPicker["+i+"]")
 
 		// Player data / defaults
 		var pData = mapSettings.PlayerData ? mapSettings.PlayerData[i] : {};
@@ -1430,8 +1462,8 @@
 		var pDefs = g_DefaultPlayerData ? g_DefaultPlayerData[i] : {};
 
 		// Common to all game types
-		var color = rgbToGuiColor(getSetting(pData, pDefs, "Color"));
-		pColor.sprite = "color:" + color + " 100";
+		var color = getSetting(pData, pDefs, "Color");
+		pColor.sprite = "color:" + rgbToGuiColor(color) + " 100";
 		pName.caption = translate(getSetting(pData, pDefs, "Name"));
 
 		var team = getSetting(pData, pDefs, "Team");
@@ -1451,6 +1483,7 @@
 		{
 			pCivText.hidden = false;
 			pCiv.hidden = true;
+			pColorPicker.hidden = true;
 			pTeamText.hidden = false;
 			pTeam.hidden = true;
 			// Set text values
@@ -1466,9 +1499,11 @@
 			pCiv.hidden = false;
 			pTeamText.hidden = true;
 			pTeam.hidden = false;
+			pColorPicker.hidden = false;
 			// Set dropdown values
 			pCiv.selected = (civ ? pCiv.list_data.indexOf(civ) : 0);
 			pTeam.selected = (team !== undefined && team >= 0) ? team+1 : 0;
+			pColorPicker.selected = g_PlayerColors.findIndex(col => sameColor(col, color));
 		}
 	}
 
Index: binaries/data/mods/public/gui/gamesetup/gamesetup.xml
===================================================================
--- binaries/data/mods/public/gui/gamesetup/gamesetup.xml	(revision 17027)
+++ binaries/data/mods/public/gui/gamesetup/gamesetup.xml	(working copy)
@@ -39,9 +39,12 @@
 			<!-- Player assignments -->
 			<object size="24 49 100%-440 345" type="image" sprite="ModernDarkBoxGold" name="playerAssignmentsPanel">
 				<object size="0 6 100% 30">
-					<object name="playerNameHeading" type="text" style="ModernLabelText" size="0 0 22% 100%">
+					<object name="playerNameHeading" type="text" style="ModernLabelText" size="0 0 16% 100%">
 						<translatableAttribute id="caption">Player Name</translatableAttribute>
 					</object>
+					<object name="playerColorHeading" type="text" style="ModernLabelText" size="-3% 0 40% 100%">
+						<translatableAttribute id="caption">Color</translatableAttribute>
+					</object>
 					<object name="playerPlacementHeading" type="text" style="ModernLabelText" size="22%+5 0 50%+35 100%">
 						<translatableAttribute id="caption">Player Placement</translatableAttribute>
 					</object>
@@ -68,7 +71,10 @@
 					<repeat count="8">
 						<object name="playerBox[n]" size="0 0 100% 32" hidden="true">
 							<object name="playerColor[n]" type="image" size="0 0 100% 100%"/>
-							<object name="playerName[n]" type="text" style="ModernLabelText" size="0 2 22% 30"/>
+							<object name="playerName[n]" type="text" style="ModernLabelText" size="0 0 16% 100%"/>
+							<object name="playerColorPicker[n]" type="dropdown" style="ModernDropDown" size="15%+5 2 20%+5 30" scrollbar="false" tooltip_style="onscreenToolTip">
+								<translatableAttribute id="tooltip">Pick a color.</translatableAttribute>
+							</object>
 							<object name="playerAssignment[n]" type="dropdown" style="ModernDropDown" size="22%+5 2 50%+35 30" tooltip_style="onscreenToolTip">
 								<translatableAttribute id="tooltip">Select player.</translatableAttribute>
 							</object>